#include <assert.h>
#include <iostream.h>
#include <ctype.h>
#include <time.h>
#include "tttbaum.h"

ostream &operator<<(ostream &ostr, const TTTBaum &b)
{
  cout << "A B C\n\n";
  cout << b.sfeld[0][0] << "|" << b.sfeld[0][1] << "|" << b.sfeld[0][2] << " 1\n";
  cout << "-----\n";
  cout << b.sfeld[1][0] << "|" << b.sfeld[1][1] << "|" << b.sfeld[1][2] << " 2\n";
  cout << "-----\n";
  cout << b.sfeld[2][0] << "|" << b.sfeld[2][1] << "|" << b.sfeld[2][2] << " 3\n";
  return(ostr);
}

bool TTTBaum::gewonnen(char pl)
{
  return
    ((sfeld[0][0]==pl)&&(sfeld[0][1]==pl)&&(sfeld[0][2]==pl)) ||
    ((sfeld[1][0]==pl)&&(sfeld[1][1]==pl)&&(sfeld[1][2]==pl)) ||
    ((sfeld[2][0]==pl)&&(sfeld[2][1]==pl)&&(sfeld[2][2]==pl)) ||
    ((sfeld[0][0]==pl)&&(sfeld[1][0]==pl)&&(sfeld[2][0]==pl)) ||
    ((sfeld[0][1]==pl)&&(sfeld[1][1]==pl)&&(sfeld[2][1]==pl)) ||
    ((sfeld[0][2]==pl)&&(sfeld[1][2]==pl)&&(sfeld[2][2]==pl)) ||
    ((sfeld[0][0]==pl)&&(sfeld[1][1]==pl)&&(sfeld[2][2]==pl)) ||
    ((sfeld[0][2]==pl)&&(sfeld[1][1]==pl)&&(sfeld[2][0]==pl));
}

bool TTTBaum::remis(void)
{
  int x,y;
  
  for(x=0;x<3;x++) {
    for(y=0;y<3;y++) {
      if (sfeld[y][x]==' ') return(0);
    }
  }
  return(1);
}


int TTTBaum::berechne(TTTKnoten *kn, char splr, char zug)
{
  int gew=0,verl=0,rem=0;
  int x,y;
  char nzug;

  anz++;
  if (!(anz%10000)) cout << anz << endl;

  if (zug=='X') {
    nzug='O';
  }
  else {
    nzug='X';
  }

  for (x=0;x<3;x++) {
    for (y=0;y<3;y++) {
      if (sfeld[y][x]==' ') {
        sfeld[y][x]=zug;
        if (gewonnen(zug)) {
          sfeld[y][x]=' ';
          if(splr==zug) {
            kn->bewertung[y][x]=3;
            return(3);
          }
          else {
            return(-2);
          }
        }
        if (remis()) {
          sfeld[y][x]=' ';
          kn->bewertung[y][x]=1;
          return(1);
        }
        kn->soehne[y][x]=new TTTKnoten;
        assert(kn->soehne[y][x]);
        anz++;
        if(!(anz%10000)) cout << anz << endl;
        kn->bewertung[y][x]=berechne(kn->soehne[y][x],splr,nzug);
        sfeld[y][x]=' ';

        if (kn->bewertung[y][x]>=2) gew++;

        if (kn->bewertung[y][x]==1) rem++;

        if (kn->bewertung[y][x]==-2) verl++;

      }
    }
  }
  if (splr==zug) {
    if (gew>0)  return( 2);
    if (rem>0)  return( 1);
    if (verl>0) return(-2);
  }
  else {
    if (verl>0)                        return(-2);
    if ((verl==0)&&(rem==0)&&(gew>0))  return( 2);
    if ((verl==0)&&((rem>0)||(gew>0))) return( 1);
  }
  return(0);
}



void TTTBaum::playGame()
{
  char inp[4];
  int x,y,zug,gew,won,rem,verl;
  TTTKnoten *spielpos;
  static time_t t;
  char chComp,chUser;


  for (x=0;x<3;x++) {
    for (y=0;y<3;y++) {
      sfeld[y][x]=' ';
    }
  }
  spielpos=wurzel;
  if (!computerStarts) {
    chComp='O';
    chUser='X';
    cout << *this << endl;
    do {
      cout << "\nIhr Spielzug :";
      cin >> inp;
      x=toupper(inp[0])-'A';
      y=inp[1]-'1';
    } while ((x<0)||(x>2)||(y<0)||(y>2)||(sfeld[y][x]!=' '));
    sfeld[y][x]=chUser;
    spielpos=spielpos->soehne[y][x];
    cout << "\n\n" << *this << endl;
  }
  else { 
    chComp='X';
    chUser='O';
  }
  
  while (true) {
    zug=gew=rem=verl=won=-1;
    for (x=0;x<3;x++) {
      for (y=0;y<3;y++) {
        if (spielpos->bewertung[y][x]==3) {
          won=y*3+x;
        }
        if (spielpos->bewertung[y][x]==2) {
          if (gew==-1) { 
            gew=y*3+x; 
          }
          else {
            if (time(&t)%2) { gew=y*3+x; }
          }
        }
        if (spielpos->bewertung[y][x]==1) {
          if (rem==-1) {
            rem=y*3+x;
          }
          else {
            if (time(&t)%2) { rem=y*3+x; }
          }
        }

        if (spielpos->bewertung[y][x]==-2) {
          if (verl==-1) { 
            verl=y*3+x; 
          }
          else { 
            if (time(&t)%2) { verl=y*3+x; }
          }
        }
      }
    }
    if (won>=0) {
      zug=won;
    }
    else {
      if (gew>=0) {
        zug=gew;
      }
      else {
        if (rem>=0) {
          zug=rem;
        }
        else {
          if (verl>=0) {
            zug=verl;
          }
        }
      }
    }
 
    if (zug>=0) {
      sfeld[zug/3][zug%3]=chComp;
      spielpos=spielpos->soehne[zug/3][zug%3];
    }
    else {
      cout << "\nKein gltiger Zug vorhanden\n\n" << endl;
      break;
    }
 
    cout << "\nMein Zug :\n";
    cout << "\n\n" << *this << endl;
    if (gewonnen(chComp)) {
      cout << "\nIch habe gewonnen !!\n" << endl;
      break;
    }
    if (remis()) {
      cout << "\nDas Spiel ist unentschieden ausgegangen.\n" << endl;
      break;
    }
 
    do {
      cout << "\nIhr Spielzug :";
      cin >> inp;
      x=toupper(inp[0])-'A';
      y=inp[1]-'1';
    } while ((x<0)||(x>2)||(y<0)||(y>2)||(sfeld[y][x]!=' '));
 
    sfeld[y][x]=chUser;
    spielpos=spielpos->soehne[y][x];
    cout << "\n\n" << *this << endl;
    if (gewonnen(chUser)) {
      cout << "\nSie haben gewonnen !!\n" << endl;
      break;
    }
    if (remis()) {
      cout << "\nDas Spiel ist unentschieden ausgegangen.\n" << endl;
      break;
    }
  }
}


TTTBaum::TTTBaum(bool computerStarts)
{
  int anz=0;
  int x,y;
  
  for (x=0;x<3;x++) {
    for (y=0;y<3;y++) {
      sfeld[y][x]=' ';
    }
  }
  wurzel=new TTTKnoten;
  assert(wurzel);
  anz=0;
  cout << "Bewerte Spielsituationen..." << endl;
  if (computerStarts) {
    berechne(wurzel,'X','X');
  }
  else {
    berechne(wurzel,'O','X');
  }
  cout << "Fertig!\n" << endl;
  this->computerStarts=computerStarts;
}
